import math
import random
from turtle import Turtle

ttl = Turtle("localhost")

LAMBDA=0.5
N=512
density = [[0 for i in range(N)] for j in range(N)] 

def reset_density():
	for i in range(N):
		for j in range(N): 
			density[i][j] = 0.0

def add_density(x0, y0, x1, y1, xc, yc, step):
	ell = math.pow(2.0, -step)
	h = math.pow(ell, LAMBDA)
	if random.randint(0,1)==0:
		h=-h ;
	for i in range(x0,x1+1):
		vi = math.sin(float(i-x0+1)/(x1-x0+2)*math.pi)
		for j in range (y0, y1+1):
			vj = math.sin(float(j-y0+1)/(y1-y0+2)*math.pi)
			density[i][j] += vi*vi*vj*vj*h

def cloud(x0, y0, x1, y1, step):
	xc = (x1-x0)/2 + x0
	yc = (y1-y0)/2 + y0
	if step>8:
		return
	add_density(x0, y0, x1, y1, xc, yc, step)
	cloud(x0, y0, xc, yc, step+1)
	cloud(xc, y0, x1, yc, step+1)
	cloud(x0, yc, xc, y1, step+1)
	cloud(xc, yc, x1, y1, step+1)


dmin=1.0E+100
dmax=-1.0E+100
ttl.clr()
n=16
while n<=N:
	random.seed(1)
	reset_density()
	cloud(0, 0, n-1, n-1, 1)
	for i in range(n):
		for j in range (n):
			if density[i][j]>dmax:
				dmax=density[i][j]
			if density[i][j]<dmin:
				dmin=density[i][j]

	s = 512/n
	ttl.north()
	ttl.lw(s)
	ttl.point()
	ttl.jump(-256,-256)
	ttl.pd()
	for i in range(n):
		for j in range(n):
			d = (density[i][j]-dmin)/(dmax-dmin)
			ttl.col(d, d, 0.4+0.6*d)
			ttl.jump(i*s-256+s/2,j*s-256+s/2)
      
	ttl.pu()
	n=n*2
